using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace yetanotherstest
{
    public partial class Form1 : Form
    {
        XmlDocument xmlDoc = new XmlDocument();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ua.SelectedIndex = 0;
            //xmlDoc.LoadXml(global::yetanotherstest.Properties.Resources.Servers);
            try
            {
                string XML = System.IO.File.ReadAllText("Servers.xml");
                xmlDoc.LoadXml(XML);
            }
            catch
            {
                //MessageBox.Show("Can't load servers from file!, the program will use the internal servers list.");
                xmlDoc.LoadXml(global::yetanotherstest.Properties.Resources.Servers);
            }

            XmlNodeList servers = xmlDoc.GetElementsByTagName("server");
            foreach (XmlElement el in servers)
            {
                bool found = false;
                foreach (object ob in cCountry.Items)
                {
                    if ((string)ob == el.GetAttribute("country"))
                    {
                        found = true;
                        break;
                    }
                }

                if (!found)
                    cCountry.Items.Add(el.GetAttribute("country"));
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                Clipboard.SetText(Result.Text);
            }
            catch
            {
                MessageBox.Show("Error: Text can't be copied!");
            }            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Result.Text = " ";
            Result.Refresh();

            string ups = UpSpeed.Value.ToString() + numericUpDown2.Value.ToString();
            string downs = DlSpeed.Value.ToString() + numericUpDown1.Value.ToString();

            string outp = HttpHelper.GetSource(downs, ups, Ping.Value.ToString() ,textBox1.Text,ua.SelectedItem.ToString());
            if (outp.StartsWith("resultid=") && outp != "resultid=0")
            {
                pictureBox1.ImageLocation = "http://www.speedtest.net/result/" + outp.Substring(9, 10) + ".png";
                Result.Text = "http://www.speedtest.net/result/" + outp.Substring(9, 10) + ".png";
                Result2.Text = "http://www.speedtest.net/my-result/" + outp.Substring(9, 10);
            }
            else
                Result.Text = outp;

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            cCity.Items.Clear();
            cCity.Text = "";
            XmlNodeList servers = xmlDoc.GetElementsByTagName("server");
            foreach (XmlElement el in servers)
            {
                if (el.GetAttribute("country") == cCountry.SelectedItem.ToString())
                    cCity.Items.Add(el.GetAttribute("name"));
            }
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            XmlNodeList servers = xmlDoc.GetElementsByTagName("server");
            foreach (XmlElement el in servers)
            {
                if (el.GetAttribute("country") == cCountry.SelectedItem.ToString())
                    if (el.GetAttribute("name") == cCity.SelectedItem.ToString())
                        textBox1.Text = el.GetAttribute("id");
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.Save();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                Clipboard.SetText(Result2.Text);
            }
            catch
            {
                MessageBox.Show("Error: Text can't be copied!");
            }    
        }
    }
}