﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.Text.RegularExpressions;
using System.Net;
using System.Security.Cryptography;

namespace yetanotherstest
{
    public static class HttpHelper
    {
        static string GetMd5Hash(MD5 md5Hash, string input)
        {
            byte[] data = md5Hash.ComputeHash(Encoding.UTF8.GetBytes(input));
            StringBuilder sBuilder = new StringBuilder();
            for (int i = 0; i < data.Length; i++)
            {
                sBuilder.Append(data[i].ToString("x2"));
            }
            return sBuilder.ToString();
        }

        public static string GetSource(string down, string up, string ping, string server,string ua)
        {

            Socket sock;
            if ((sock = SendSocket("www.speedtest.net", 80)) == null)
                return "FAIL";

            string hash = GetMd5Hash(MD5.Create(), string.Format("{0}-{1}-{2}-297aae72", ping, up, down));

            Random r = new Random();
            int iacc = 7 + r.Next(20);
            string acc = iacc.ToString();

            string ss = string.Format("startmode=recommendedselect&promo=&upload={0}&accuracy={1}&recommendedserverid={2}&serverid={3}&ping={4}&hash={5}&download={6}", up, acc, server, server, ping, hash, down);
            //System.Windows.Forms.MessageBox.Show(ss);
            //System.Windows.Forms.Application.Exit();

            List<HttpHeader> Hea = new List<HttpHeader>();
            Hea.Add(new HttpHeader("POST /api/api.php HTTP/1.1"));
            Hea.Add(new HttpHeader("Host", "www.speedtest.net"));
            Hea.Add(new HttpHeader("User-Agent",ua));

            Hea.Add(new HttpHeader("Referer", "http://c.speedtest.net/flash/speedtest.swf"));
            Hea.Add(new HttpHeader("Origin", "http://c.speedtest.net"));
            Hea.Add(new HttpHeader("content-type", "application/x-www-form-urlencoded"));
            Hea.Add(new HttpHeader("Content-Length", ss.Length.ToString()));
            Hea.Add(new HttpHeader("Connection", "Close"));

            SendHeaders(Hea, sock);
            WriteData(ss, sock);

            string retbuff = "";

            byte[] buffer = new byte[1024 * 8];
            int rec;
            while ((rec = sock.Receive(buffer, SocketFlags.None)) > 0)
                retbuff += Encoding.ASCII.GetString(buffer, 0, rec);

            return retbuff.Substring(retbuff.IndexOf("\r\n\r\n") + 4, retbuff.Length - retbuff.IndexOf("\r\n\r\n") - 4);
        }

        private static Socket SendSocket(string host, int port)
        {
            IPAddress Address = Dns.GetHostEntry(host).AddressList[0];
            return SendSocket(Address, port);
        }

        private static Socket SendSocket(IPAddress Address, int port)
        {
            IPEndPoint ipe = new IPEndPoint(Address, port);
            Socket socket = new Socket(Address.AddressFamily, SocketType.Stream, ProtocolType.Tcp);
            socket.Connect(ipe);

            if (socket.Connected)
                return socket;

            return null;
        }

        private static bool WriteData(string data, Socket sock)
        {
            if (sock.Send(Encoding.ASCII.GetBytes(data), data.Length, SocketFlags.None) >= 0)
                return true;

            return false;
        }

        private static bool SendHeaders(List<HttpHeader> Headers, Socket sock)
        {
            string head = "";
            foreach (HttpHeader header in Headers)
            {
                if (header.Value != null)
                    head += string.Format("{0}: {1}\r\n", header.Name, header.Value);
                else
                    head += string.Format("{0}\r\n", header.Name);
            }
            head += "\r\n";

            if (sock.Send(Encoding.ASCII.GetBytes(head), head.Length, SocketFlags.None) >= 0)
                return true;

            return false;
        }
    }
}
